Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.ohf.ihe.atna.audit.client
Interface ATNAAuditClient

All Known Implementing Classes:
  ATNAAuditClientDummy

    public interface ATNAAuditClient

Interface for IHE clients to record audit events (Transaction ITI-20: Record Audit Event)

Author:
  Sarah Knoop
See Also:
  IHE Technical Framework

Field Summary
`static int` | `MINOR_FAILURE_EVENT_OUTCOME` Constant to indicate that a transaction involving private health information experienced a minor failure.
`static int` | `NODE_AUTHENTICATION_FAILURE` Constant to indicate that a transaction involving private health information experienced node authentication failure.
`static int` | `SERIOUS_FAILURE_EVENT_OUTCOME` Constant to indicate that a transaction involving private health information experienced a serious failure.
`static int` | `SUCCESS_EVENT_OUTCOME` Constant to indicate that a transaction involving private health information was successful.

Method Summary
`void` | `audit(int eventOutcome, java.lang.String initiatingUser, java.lang.String transactionPayload)` Transaction ITI-20: Record Audit Event Dummy implemetation of the following: Constructs the audit message and sends it to the audit repository on behalf of an Application or IHE Actor.
`void` | `auditActorStartEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String dataRecipientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Application Start Audit Event to the Audit Repository.
`void` | `auditActorStopEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String dataRecipientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Application Stop Audit Event to the Audit Repository.
`void` | `auditPatientRecordCreateEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String patientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Patient Record Audit Event, which indicates that a CREATING of a patient record took place, to the Audit Repository.
`void` | `auditPatientRecordDeleteEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String patientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Patient Record Audit Event, which indicates that a DELETING of a patient record took place, to the Audit Repository.
`void` | `auditPatientRecordReadEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String patientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Patient Record Audit Event, which indicates that a READING of a patient record took place, to the Audit Repository.
`void` | `auditPatientRecordUpdateEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String patientId)` Transaction ITI-20: Record Audit Event Method to call that will send a Patient Record Audit Event, which indicates that a UPDATING of a patient record took place, to the Audit Repository.
`void` | `auditPHIExportEvent(int eventOutcome, java.lang.String initatingUser, java.lang.String dataRecipientId, java.lang.String exportedDataId, java.lang.String patientId)` Transaction ITI-20: Record Audit Event Method to call that will send a PHI Export Audit Event to the Audit Repository.
`void` | `auditPHIImportEvent(int eventOutcome, java.lang.String initatingUser, java.lang.String dataSourceId, java.lang.String[] patientId, java.lang.String importedData)` Transaction ITI-20: Record Audit Event Method to call that will send a PHI Import Audit Event to the Audit Repository.
`void` | `auditQueryEvent(int eventOutcome, java.lang.String initatingUser, java.lang.String registryID, java.lang.String queryText)` Transaction ITI-20: Record Audit Event Method to call that will send a Query Audit Event to the Audit Repository.
`void` | `auditUserAuthenticationLoginEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String initiatingUserName, java.lang.String initiatingUserNodeIP, java.lang.String authenticatingNodeIP)` Transaction ITI-20: Record Audit Event Method to call that will send a User Authentication Event, which indicates that a LOGIN took place, to the Audit Repository.
`void` | `auditUserAuthenticationLogoutEvent(int eventOutcome, java.lang.String initiatingUser, java.lang.String initiatingUserName, java.lang.String initiatingUserNodeIP, java.lang.String authenticatingNodeIP)` Transaction ITI-20: Record Audit Event Method to call that will send a User Authentication Event, which indicates that a LOGIN took place, to the Audit Repository.

Field Detail

### SUCCESS_EVENT_OUTCOME

    static final int SUCCESS_EVENT_OUTCOME

  Constant to indicate that a transaction involving private health information was successful.

  See Also:
    Constant Field Values

### SERIOUS_FAILURE_EVENT_OUTCOME

    static final int SERIOUS_FAILURE_EVENT_OUTCOME

  Constant to indicate that a transaction involving private health information experienced a serious failure.

  See Also:
    Constant Field Values

### NODE_AUTHENTICATION_FAILURE

    static final int NODE_AUTHENTICATION_FAILURE

  Constant to indicate that a transaction involving private health information experienced node authentication failure.

  See Also:
    Constant Field Values

### MINOR_FAILURE_EVENT_OUTCOME

    static final int MINOR_FAILURE_EVENT_OUTCOME

  Constant to indicate that a transaction involving private health information experienced a minor failure.

  See Also:
    Constant Field Values

Method Detail

### audit

    void audit(int eventOutcome,
               java.lang.String initiatingUser,
               java.lang.String transactionPayload)

  Transaction ITI-20: Record Audit Event
  Dummy implemetation of the following:
  Constructs the audit message and sends it to the audit repository on behalf of an Application or IHE Actor.

  Parameters:
    `eventOutcome` - status code of the event to be audited (success or failure to access patient(s) information)
    `initiatingUser` - the id of the entity that triggered the transaction concering the patient(s) information, thus triggering the audit event
    `transactionPayload` - transactional data used to obtain information about the patient(s) or containing information about the patient(s)

### auditQueryEvent

    void auditQueryEvent(int eventOutcome,
                         java.lang.String initatingUser,
                         java.lang.String registryID,
                         java.lang.String queryText)
                         throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Query Audit Event to the Audit Repository. For use by the XDS Consumer, PIX Consumer and PDQ Consumer.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the Consumer
    `registryID` - Id of the entity that is responsible for answering the query (ie. XDS Registry or the PIX/PDQ Server)
    `queryText` - complete text of the query issued.
  Throws:
    `ATNAException`
    `javax.xml.parsers.FactoryConfigurationError`
    `javax.xml.parsers.ParserConfigurationException`
    `ATNAAuditClientException`

### auditPHIImportEvent

    void auditPHIImportEvent(int eventOutcome,
                             java.lang.String initatingUser,
                             java.lang.String dataSourceId,
                             java.lang.String[] patientId,
                             java.lang.String importedData)
                             throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a PHI Import Audit Event to the Audit Repository. For use by the XDS Consumer, PIX Consumer and PDQ Consumer.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `dataSourceId` - where the imported data came from (ie. the XDS Registry or the PIX/PDQ server)
    `patientId` - Patient Id from within imported data
    `importedData` - exact data or UUID/uniqueId of data imported as a String
  Throws:
    `ATNAAuditClientException`

### auditPHIExportEvent

    void auditPHIExportEvent(int eventOutcome,
                             java.lang.String initatingUser,
                             java.lang.String dataRecipientId,
                             java.lang.String exportedDataId,
                             java.lang.String patientId)
                             throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a PHI Export Audit Event to the Audit Repository. For use by the XDS Source and PIX Source

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `dataRecipientId` - where the exported data is going (ie. the XDS Repository or the PIX/PDQ server)
    `exportedDataId` - UUID/uniqueId of data exported as a String
    `patientId` - the id of the patient this data pertains to
  Throws:
    `ATNAAuditClientException`

### auditActorStartEvent

    void auditActorStartEvent(int eventOutcome,
                              java.lang.String initiatingUser,
                              java.lang.String dataRecipientId)
                              throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Application Start Audit Event to the Audit Repository. For use by all actors.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `dataRecipientId` - where the exported data is going (ie. the XDS Repository or the PIX/PDQ server)
  Throws:
    `ATNAAuditClientException`

### auditActorStopEvent

    void auditActorStopEvent(int eventOutcome,
                             java.lang.String initiatingUser,
                             java.lang.String dataRecipientId)
                             throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Application Stop Audit Event to the Audit Repository. For use by all actors.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `dataRecipientId` - where the exported data is going (ie. the XDS Repository or the PIX/PDQ server)
  Throws:
    `ATNAAuditClientException`

### auditPatientRecordReadEvent

    void auditPatientRecordReadEvent(int eventOutcome,
                                     java.lang.String initiatingUser,
                                     java.lang.String patientId)
                                     throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Patient Record Audit Event, which indicates that a READING of a patient record took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `patientId` - the id of the patient the record pertains to
  Throws:
    `ATNAAuditClientException`

### auditPatientRecordCreateEvent

    void auditPatientRecordCreateEvent(int eventOutcome,
                                       java.lang.String initiatingUser,
                                       java.lang.String patientId)
                                       throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Patient Record Audit Event, which indicates that a CREATING of a patient record took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `patientId` - the id of the patient the record pertains to
  Throws:
    `ATNAAuditClientException`

### auditPatientRecordUpdateEvent

    void auditPatientRecordUpdateEvent(int eventOutcome,
                                       java.lang.String initiatingUser,
                                       java.lang.String patientId)
                                       throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Patient Record Audit Event, which indicates that a UPDATING of a patient record took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `patientId` - the id of the patient the record pertains to
  Throws:
    `ATNAAuditClientException`

### auditPatientRecordDeleteEvent

    void auditPatientRecordDeleteEvent(int eventOutcome,
                                       java.lang.String initiatingUser,
                                       java.lang.String patientId)
                                       throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a Patient Record Audit Event, which indicates that a DELETING of a patient record took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `patientId` - the id of the patient the record pertains to
  Throws:
    `ATNAAuditClientException`

### auditUserAuthenticationLoginEvent

    void auditUserAuthenticationLoginEvent(int eventOutcome,
                                           java.lang.String initiatingUser,
                                           java.lang.String initiatingUserName,
                                           java.lang.String initiatingUserNodeIP,
                                           java.lang.String authenticatingNodeIP)
                                           throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a User Authentication Event, which indicates that a LOGIN took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `initiatingUserName` - the name of the user logging in
    `initiatingUserNodeIP` - the IP Address of the node the user is logging into
    `authenticatingNodeIP` - the IP Address of the node that is authenticating the user
  Throws:
    `ATNAAuditClientException`

### auditUserAuthenticationLogoutEvent

    void auditUserAuthenticationLogoutEvent(int eventOutcome,
                                            java.lang.String initiatingUser,
                                            java.lang.String initiatingUserName,
                                            java.lang.String initiatingUserNodeIP,
                                            java.lang.String authenticatingNodeIP)
                                            throws ATNAAuditClientException

  Transaction ITI-20: Record Audit Event
  Method to call that will send a User Authentication Event, which indicates that a LOGIN took place, to the Audit Repository.

  Parameters:
    `eventOutcome` - event outcome from `AtnaAuditClient`
    `initatingUser` - User Id passed along to the IHE Actor
    `initiatingUserName` - the name of the user logging in
    `initiatingUserNodeIP` - the IP Address of the node the user is logging into
    `authenticatingNodeIP` - the IP Address of the node that is authenticating the user
  Throws:
    `ATNAAuditClientException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD